Attribute VB_Name = "Module1"
'Configuration coordonns pointeur
Public Declare Function SetCursorPos& Lib "user32" (ByVal X As Long, ByVal Y As Long)
Public Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long



Global HGLRC As Long
Global bmpH As Integer
Global bmpW As Integer
Global baImageData() As Byte
Global TextureP As Long
Global TextureT As Long

Public obj As Long


Private Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Long
  bmBitsPixel As Long
  bmBits As Long
End Type

Public Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type

Public Type RGBQUAD
  rgbBlue As Byte
  rgbGreen As Byte
  rgbRed As Byte
  rgbReserved As Byte
End Type

Public Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As RGBQUAD
End Type

Public Const GL_BITMAP As Integer = &H1A00

Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long





Public Sub AddTexture(sFile As String)
On Error Resume Next
'---Ouverture du fichier BMP---
'le fichier BMP doit tre en mode 24 bit couleurs

Dim bmFile As BITMAPFILEHEADER
Dim bmInfo As BITMAPINFOHEADER
Dim bmRGB() As RGBQUAD
Dim iFile As Integer
Dim lImageSize As Long
Dim iPixelSize As Integer
  
  iFile = FreeFile
  
  Open sFile For Binary As iFile
  Get #iFile, , bmFile
  Get #iFile, , bmInfo
  
  If (bmInfo.biBitCount < 24) Then
    ReDim bmRGB(bmInfo.biClrUsed)
    Get #iFile, , bmRGB
  End If
  
  iPixelSize = bmInfo.biBitCount / 8
  lImageSize = bmInfo.biWidth * bmInfo.biHeight * iPixelSize
  ReDim baImageData(lImageSize)
  
  Get #iFile, , baImageData
  Close #iFile

bmpW = bmInfo.biWidth
bmpH = bmInfo.biHeight




glGenTextures 1, TextureP 'permet de donn un numero a la texture
'                         ici le numero est design par TextureP
glBindTexture glTexture2D, TextureP 'Indique le type de texture et oui y a d'autre type de texture comme des texture en 3d
'glbindTexture Type_de_textue,numero_de_la_texture



'suivit imadiatement des 2 premiere ligne
'rentre toute les donnes dont opengl a besoin sur la texture de numero TextureP
'glTextImage2D type_texture,Mipmap,couleur,largeur,hauteur,largeur_d'un_bord,format_couleur,Type_des_couleurs,adresse_image

glTexImage2D glTexture2D, 0, 4, bmpW, bmpH, 0, tiBGRExt, GL_UNSIGNED_BYTE, baImageData(0)
glTexParameteri glTexture2D, tpnTextureMagFilter, GL_NEAREST
glTexParameteri glTexture2D, tpnTextureMinFilter, GL_NEAREST

End Sub


Public Sub Salle()
glColor3f 1, 1, 1

glBindTexture glTexture2D, 1 'rappelle la texture n1

glBegin bmQuads ' indique  opengl ke l'on va tracer des carrs
For X = -15 To 15 Step 1
 For Z = -15 To 15 Step 1
 
 'les textures que j'utilise sont de forme carr donc on 4 coins de la forme :
 '
 '   0,1              1,1            o,1 / 1,1 / 0,0 / 0,1 : represente les coordonnes de chaque coin
 '     --------------                  du carr en faite c'est comme si la texture
 '     |            |                  avait une dimension de 1*1
 '     |            |
'      |            |
 '     |            |
 '     |            |
 '     --------------
 '    0,0          0,1
 
 
 'le dol
  glTexCoord2d 0, 0  ' plaque le premier coin de la texture
 glVertex3f X, 0, Z 'premier coin du carr
  glTexCoord2d 1, 0 ' plaque le 2me coin de la texture
 glVertex3f X + 1, 0, Z '2me coin
  glTexCoord2d 1, 1 ' plaque le 3 me coin de la texture
 glVertex3f X + 1, 0, Z + 1 '3 me coin
  glTexCoord2d 0, 1 ' plaque le 4 me coin de la texture
 glVertex3f X, 0, Z + 1 '4me coin

 Next
Next
glEnd 'indique  opengl qu'on a finit de trac nos carr pr le sol


glBindTexture glTexture2D, 2 'rappelle la texure n2
glBegin bmQuads 'indique qu'on va dessiner des carrs pour les mur
For Z = -15 To 15
For Y = 0 To 7
'mur de droite
glTexCoord2d 0, 0
glVertex3f 15, Y, Z
glTexCoord2d 1, 0
glVertex3f 15, Y, Z + 1
glTexCoord2d 1, 1
glVertex3f 15, Y + 1, Z + 1
glTexCoord2d 0, 1
glVertex3f 15, Y + 1, Z
'mur de gauche
glTexCoord2d 0, 0
glVertex3f -15, Y, Z
glTexCoord2d 1, 0
glVertex3f -15, Y, Z + 1
glTexCoord2d 1, 1
glVertex3f -15, Y + 1, Z + 1
glTexCoord2d 0, 1
glVertex3f -15, Y + 1, Z
Next
Next

For X = -15 To 15
For Y = 0 To 7
'mur de devant
glTexCoord2d 0, 0
glVertex3f X, Y, 15
glTexCoord2d 1, 0
glVertex3f X + 1, Y, 15
glTexCoord2d 1, 1
glVertex3f X + 1, Y + 1, 15
glTexCoord2d 0, 1
glVertex3f X, Y + 1, 15
'mur de derrire
glTexCoord2d 0, 0
glVertex3f X, Y, -15
glTexCoord2d 1, 0
glVertex3f X + 1, Y, -15
glTexCoord2d 1, 1
glVertex3f X + 1, Y + 1, -15
glTexCoord2d 0, 1
glVertex3f X, Y + 1, -15
Next
Next

glEnd 'indique  opengl qu'on a finit de trac nos carr
End Sub
